using Adaptation.Shared.Methods;
using Microsoft.Extensions.Logging;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Shared;
using System;
using System.Diagnostics;
using System.IO;
using System.Reflection;

namespace _Tests.CreateSelfDescription.Staging.v2_36_3
{

    [TestClass]
    public class BIORAD3 : EAFLoggingUnitTesting
    {

        private static BIORAD3 _EAFLoggingUnitTesting;
        internal static BIORAD3 EAFLoggingUnitTesting => _EAFLoggingUnitTesting;

        public BIORAD3() : base(testContext: null, declaringType: null, skipEquipmentDictionary: false)
        {
            if (_EAFLoggingUnitTesting is null)
                throw new Exception();
        }

        public BIORAD3(TestContext testContext) : base(testContext, new StackFrame().GetMethod().DeclaringType, skipEquipmentDictionary: false)
        {
        }

        [ClassInitialize]
        public static void ClassInitialize(TestContext testContext)
        {
            if (_EAFLoggingUnitTesting is null)
                _EAFLoggingUnitTesting = new BIORAD3(testContext);
            _EAFLoggingUnitTesting.Logger.LogInformation(string.Concat(testContext.TestName, " - ClassInitialize"));
            string[] fileNameAndText = _EAFLoggingUnitTesting.AdaptationTesting.GetCSharpText(testContext.TestName);
            File.WriteAllText(fileNameAndText[0], fileNameAndText[1]);
            File.WriteAllText(fileNameAndText[2], fileNameAndText[3]);
        }

        [ClassCleanup()]
        public static void ClassCleanup()
        {
            if (!(_EAFLoggingUnitTesting.Logger is null))
                _EAFLoggingUnitTesting.Logger.LogInformation("Cleanup");
            if (!(_EAFLoggingUnitTesting is null))
                _EAFLoggingUnitTesting.Dispose();
        }

        [TestMethod]
        public void Staging__v2_36_3__BIORAD3__QS408M()
        {
            string check = "*.txt";
            MethodBase methodBase = new StackFrame().GetMethod();
            _EAFLoggingUnitTesting.Logger.LogInformation(string.Concat(methodBase.Name, " - Getting configuration"));
            string[] fileNameAndJson = _EAFLoggingUnitTesting.AdaptationTesting.GetConfiguration(methodBase);
            Assert.IsTrue(fileNameAndJson[1].Contains(check));
            File.WriteAllText(fileNameAndJson[0], fileNameAndJson[1]);
            IFileRead fileRead = _EAFLoggingUnitTesting.AdaptationTesting.Get(methodBase, sourceFileLocation: string.Empty, sourceFileFilter: string.Empty, useCyclicalForDescription: false);
            Assert.IsFalse(string.IsNullOrEmpty(fileRead.CellInstanceConnectionName));
            _EAFLoggingUnitTesting.Logger.LogInformation(string.Concat(methodBase.Name, " - Exit"));
        }

    }

}

// dotnet build --runtime win-x64
// dotnet test --runtime win-x64 --no-build --filter "FullyQualifiedName~_Tests.CreateSelfDescription.Staging.v2_36_3" --% -- TestRunParameters.Parameter(name=\"Debug\", value=\"Debugger.IsAttached\")
// dotnet test --runtime win-x64 --no-build --filter "FullyQualifiedName~_Tests.CreateSelfDescription.Staging.v2_36_3 & ClassName~BIORAD3" --% -- TestRunParameters.Parameter(name=\"Debug\", value=\"Debugger.IsAttached\")
// dotnet test --runtime win-x64 --no-build --filter "FullyQualifiedName~_Tests.CreateSelfDescription.Staging.v2_36_3 & ClassName~BIORAD3 & Staging__v2_36_3__BIORAD3__QS408M" --% -- TestRunParameters.Parameter(name=\"Debug\", value=\"Debugger.IsAttached\")